Attribute VB_Name = "modWIC"
' Autor: F. Schler (frank@activevb.de)
' Datum: 11/2018

Option Explicit

' **************** WIC Const ****************
Public Const WINCODEC_SDK_VERSION_1 As Long = &H236& ' ab WinXP SP2 mit installiertem WIC, ansonsten ab WinXP SP3 und hher
Public Const WINCODEC_SDK_VERSION_2 As Long = &H237& ' ab Win7 SP1 mit PLATFORM_UPDATE (KB2670838), ansonsten ab Win8 und hher

' **************** WIC ContainerFormat Const ****************
Public Const GUID_ContainerFormatGif As String = "{1f8a5601-7d4d-4cbd-9c82-1bc8d4eeb9a5}"

' **************** WIC PixelFormat Const ****************
Public Const GUID_WICPixelFormat8bppIndexed As String = "{6fddc324-4e03-4bfe-b185-3d77768dc904}"

' **************** WIC IID Const ****************
Public Const IID_IWICBitmapSource As String = "{00000120-a8f2-4877-ba0a-fd2b6645fb94}"

' **************** WIC Enums ****************
Public Enum WICDecodeOptions
    WICDecodeMetadataCacheOnDemand = &H0&
    WICDecodeMetadataCacheOnLoad = &H1&
End Enum

Public Enum WICBitmapEncoderCacheOption
    WICBitmapEncoderCacheInMemory = &H0&
    WICBitmapEncoderCacheTempFile = &H1&
    WICBitmapEncoderNoCache = &H2&
End Enum

Public Enum WICAccessOption
    GENERIC_READ = &H80000000
    GENERIC_WRITE = &H40000000
End Enum

Public Enum WICBitmapDitherType
    WICBitmapDitherTypeNone = &H0&
    WICBitmapDitherTypeSolid = &H0&
    WICBitmapDitherTypeOrdered4x4 = &H1&
    WICBitmapDitherTypeOrdered8x8 = &H2&
    WICBitmapDitherTypeOrdered16x16 = &H3&
    WICBitmapDitherTypeSpiral4x4 = &H4&
    WICBitmapDitherTypeSpiral8x8 = &H5&
    WICBitmapDitherTypeDualSpiral4x4 = &H6&
    WICBitmapDitherTypeDualSpiral8x8 = &H7&
    WICBitmapDitherTypeErrorDiffusion = &H8&
End Enum

Public Enum WICBitmapPaletteType
    WICBitmapPaletteTypeCustom = &H0&
    WICBitmapPaletteTypeMedianCut = &H1&
    WICBitmapPaletteTypeFixedBW = &H2&
    WICBitmapPaletteTypeFixedHalftone8 = &H3&
    WICBitmapPaletteTypeFixedHalftone27 = &H4&
    WICBitmapPaletteTypeFixedHalftone64 = &H5&
    WICBitmapPaletteTypeFixedHalftone125 = &H6&
    WICBitmapPaletteTypeFixedHalftone216 = &H7&
    WICBitmapPaletteTypeFixedWebPalette = WICBitmapPaletteTypeFixedHalftone216
    WICBitmapPaletteTypeFixedHalftone252 = &H8&
    WICBitmapPaletteTypeFixedHalftone256 = &H9&
    WICBitmapPaletteTypeFixedGray4 = &HA&
    WICBitmapPaletteTypeFixedGray16 = &HB&
    WICBitmapPaletteTypeFixedGray256 = &HC&
End Enum

Public Enum DISPOSAL_METHODS
    DM_UNDEFINED = 0
    DM_NONE = 1
    DM_BACKGROUND = 2
    DM_PREVIOUS = 3
End Enum

' **************** WIC Types ****************
Public Type WICRect
    x As Long
    y As Long
    width As Long
    height As Long
End Type

' **************** WIC Proxy APIs ****************
Public Declare Function IWICBitmapEncoder_Commit_Proxy Lib "Windowscodecs.dll" ( _
                        ByVal pIWICBitmapEncoder As Long) As Long

Public Declare Function IWICBitmapEncoder_CreateNewFrame_Proxy Lib "Windowscodecs.dll" ( _
                        ByVal pIWICEncoder As Long, _
                        ByRef ppIFrameEncode As Long, _
                        ByRef ppIEncoderOptions As Long) As Long

Public Declare Function IWICBitmapEncoder_GetMetadataQueryWriter_Proxy Lib "Windowscodecs.dll" ( _
                        ByVal pIWICBitmapEncoder As Long, _
                        ByRef ppIMetadataQueryWriter As Long) As Long

Public Declare Function IWICBitmapEncoder_Initialize_Proxy Lib "Windowscodecs.dll" ( _
                        ByVal pIWICEncoder As Long, _
                        ByVal pIStream As Long, _
                        ByVal cacheOption As WICBitmapEncoderCacheOption) As Long

Public Declare Function IWICBitmapDecoder_GetFrame_Proxy Lib "Windowscodecs.dll" ( _
                        ByVal pIWICDecoder As Long, _
                        ByVal index As Long, _
                        ByRef ppIBitmapFrame As Long) As Long

Public Declare Function IWICBitmapDecoder_GetFrameCount_Proxy Lib "Windowscodecs.dll" ( _
                        ByVal pIWICDecoder As Long, _
                        ByRef pCount As Long) As Long

Public Declare Function IWICBitmapFrameEncode_Commit_Proxy Lib "Windowscodecs.dll" ( _
                        ByVal pIWICBitmapFrameEncode As Long) As Long

Public Declare Function IWICBitmapFrameEncode_GetMetadataQueryWriter_Proxy Lib "Windowscodecs.dll" ( _
                        ByVal pIWICBitmapFrameEncode As Long, _
                        ByRef ppIMetadataQueryWriter As Long) As Long

Public Declare Function IWICBitmapFrameEncode_Initialize_Proxy Lib "Windowscodecs.dll" ( _
                        ByVal pIWICBitmapFrameEncode As Long, _
                        ByVal pIEncoderOptions As Long) As Long

Public Declare Function IWICBitmapFrameEncode_SetSize_Proxy Lib "Windowscodecs.dll" ( _
                        ByVal pIWICBitmapFrameEncode As Long, _
                        ByVal uiWidth As Long, _
                        ByVal uiHeight As Long) As Long

Public Declare Function IWICBitmapFrameEncode_WriteSource_Proxy Lib "Windowscodecs.dll" ( _
                        ByVal pIWICBitmapFrameEncode As Long, _
                        ByVal pIWICBitmapSource As Long, _
                        ByRef prc As WICRect) As Long

Public Declare Function IWICBitmapSource_GetSize_Proxy Lib "Windowscodecs.dll" ( _
                        ByVal pIWICBitmapSource As Long, _
                        ByRef puiWidth As Long, _
                        ByRef puiHeight As Long) As Long

Public Declare Function IWICFormatConverter_Initialize_Proxy Lib "Windowscodecs.dll" ( _
                        ByVal pIWICFormatConverter As Long, _
                        ByVal pISource As Long, _
                        ByRef dstFormat As GUID, _
                        ByVal dither As WICBitmapDitherType, _
                        ByVal pIPalette As Long, _
                        ByVal alphaThresholdPercent As Double, _
                        ByVal paletteTranslate As WICBitmapPaletteType) As Long

Public Declare Function IWICImagingFactory_CreateStream_Proxy Lib "Windowscodecs.dll" ( _
                        ByVal pFactory As Long, _
                        ByRef ppIWICStream As Long) As Long

Public Declare Function IWICImagingFactory_CreateEncoder_Proxy Lib "Windowscodecs.dll" ( _
                        ByVal pFactory As Long, _
                        ByRef guidContainerFormat As GUID, _
                        ByVal pguidVendor As Long, _
                        ByRef ppIEncoder As Long) As Long

Public Declare Function IWICImagingFactory_CreateDecoderFromFilename_Proxy Lib "Windowscodecs.dll" ( _
                        ByVal pFactory As Long, _
                        ByVal wzFilename As Long, _
                        ByVal pguidVendor As Long, _
                        ByVal dwDesiredAccess As WICAccessOption, _
                        ByVal metadataOptions As WICDecodeOptions, _
                        ByRef ppIDecoder As Long) As Long

Public Declare Function IWICImagingFactory_CreateFormatConverter_Proxy Lib "Windowscodecs.dll" ( _
                        ByVal pFactory As Long, _
                        ByRef ppIFormatConverter As Long) As Long

Public Declare Function IWICImagingFactory_CreatePalette_Proxy Lib "Windowscodecs.dll" ( _
                        ByVal pFactory As Long, _
                        ByRef ppIPalette As Long) As Long

Public Declare Function IWICMetadataQueryWriter_SetMetadataByName_Proxy Lib "Windowscodecs.dll" ( _
                        ByVal pIWICMetadataQueryWriter As Long, _
                        ByVal wzName As Long, _
                        ByVal pvarValue As Long) As Long

Public Declare Function IWICPalette_InitializeFromBitmap_Proxy Lib "Windowscodecs.dll" ( _
                        ByVal pIWICPalette As Long, _
                        ByVal pISurface As Long, _
                        ByVal colorCount As Long, _
                        ByVal fAddTransparentColor As Long) As Long

Public Declare Function IWICStream_InitializeFromIStream_Proxy Lib "Windowscodecs.dll" ( _
                        ByVal pIWICStream As Long, _
                        ByVal pIStream As Long) As Long

Public Declare Function WICCreateImagingFactory_Proxy Lib "Windowscodecs.dll" ( _
                        ByVal SDKVersion As Long, _
                        ByRef ppIImagingFactory As Long) As Long
